do graphs=class()
	graphs.plots={}
	graphs.min={-10, -10}
	graphs.max={10, 10}
	
	function graphs:setRange(minX, minY, maxX, maxY)
		self.min={minX, minY}
		self.max={maxX, maxY}
	end
	
	function graphs:getXY(point)
		local x, y=point[1], point[2]
		x=x-self.min[1]
		y=y-self.min[2]
		x=x*dispX/(self.max[1]-self.min[1])
		y=y*dispY/(self.max[2]-self.min[2])
		return {x, y}
	end
	
	function graphs:paint(gc)
		for _, p in pairs(self.plots) do
			if p.tp=="pts" then
				for i=1, #p.data-1 do
					local points={self:getXY(p.data[i]), self:getXY(p.data[i+1])}
					gc:drawLine(points[1][1], points[1][2], points[2][1], points[2][2])
				end
			elseif p.tp=="ptsStat" then
				for __, d in pairs(p.data) do
					local point=self:getXY(d)
					gc:fillRect(point[1], point[2], 1, 1)
				end
			elseif p.tp=="func" then
				
			end
		end
	end
	
	function graphs:addPlot(plot)
		self.plots[#self.plots+1]=plot
	end
	
	function graphs:reset()
		self.plots={}
	end
end

do plot=class()
	plot.tp="pts"--(type): pts(points, connected by lines), ptsStat(only graph points, dont connect), and func(function)
	plot.data=nil
	plot.color=0x000000
	
	function plot:setType(tp)
		self.tp=tp
		if tp=="pts" or tp=="ptsStat" then
			self.data={}
		elseif tp=="func"
			self.data=""
		end
	end
	
	function plot:setEquation(equation)
		self.data=equation
	end
	
	function plot:addPoint(x, y)--does nothing if plot type is func
		if self.tp=="pts" or self.tp=="ptsStat" then
			self.data[#self.data+1]={x, y}
		end
	end
	
	function plot:setColor(color)
		self.color=color
	end
end