do hitbox=class()
	hitbox.width=0
	hitbox.height=0
	
	function round(num)--to nearest int
		return math.floor(num+0.5)
	end
	
	function hitbox:init(width, height)
		self.width=width
		self.height=height
		self:rst()
	end
	
	function hitbox:test(x, y, targX, targY)--x, y is top left
		if targX~=nil and targY~=nil then
			targX=round(targX-x)
			targY=round(targY-y)
			if targX>=0 and targX<self.width and targY>=0 and targY<self.height then
				return self.bpp[targX+1][targY+1]
			end
		end
		return false
	end
	
	function hitbox:testOther(x, y, x2, y2, htbx)
		for i=0, #self.bpp-1 do
			for j=0, #self.bpp[i]-1 do
				
			end
		end
	end
	
	function hitbox:rst()
		self.bpp={}
		for i=1, self.width do
			self.bpp[i]={}
			for j=1, self.height do
				self.bpp[i][j]=false
			end
		end
	end
	
	function hitbox:draw(gc, x, y)
		for i=1, self.width do
			for j=1, self.height do
				if self.bpp[i][j] then
					gc:drawPoint(i-1+x, j-1+y)
				end
			end
		end
	end
	
	function hitbox:point(x, y)
		x=round(x)
		y=round(y)
		if x>=0 and x<self.width and y>=0 and y<self.height then
			self.bpp[x+1][y+1]=true
		end
	end
	
	function hitbox:horizLine(x, y, length)
		for i=x, x+length do
			self:point(i, y)
		end
	end
	
	function hitbox:verticalLine(x, y, height)
		for i=y, y+height do
			self:point(x, i)
		end
	end
	
	function hitbox:fillTriangle(x1, y1, x2, y2, x3, y3)
		local points={{x1, y1}, {x2, y2}, {x3, y3}}
		for i=1, 3 do
			for j=i,3 do
				if points[i][2]>points[j][2] then
					local tmp={points[i][1], points[i][2]}
					points[i][1]=points[j][1]
					points[i][2]=points[j][2]
					points[j][1]=tmp[1]
					points[j][2]=tmp[2]
				elseif points[i][2]==points[j][2] then
					if points[i][1]>points[j][1] then
						local tmp={points[i][1], points[i][2]}
						points[i][1]=points[j][1]
						points[i][2]=points[j][2]
						points[j][1]=tmp[1]
						points[j][2]=tmp[2]
					end
				end
			end
		end
		if points[1][2]==points[2][2] then--two points are smaller coords. increment y
			local xSlope1=(points[3][1]-points[1][1])/(points[3][2]-points[1][2])
			local xSlope2=(points[3][1]-points[2][1])/(points[3][2]-points[2][2])
			local startX=points[1][1]
			local endX=points[2][1]
			if endX<startX then
				local tmp=xSlope1
				xSlope1=xSlope2
				xSlope2=tmp
				tmp=startX
				startX=endX
				endX=tmp
			end
			for i=points[1][2], points[3][2] do
				self:horizLine(startX, i, endX-startX)
				startX=startX+xSlope1
				endX=endX+xSlope2
			end
		elseif points[2][2]==points[3][2] then--two points are larger coords. decrement y
			local xSlope1=-(points[1][1]-points[2][1])/(points[1][2]-points[2][2])
			local xSlope2=-(points[1][1]-points[3][1])/(points[1][2]-points[3][2])
			local startX=points[2][1]
			local endX=points[3][1]
			if endX<startX then
				local tmp=xSlope1
				xSlope1=xSlope2
				xSlope2=tmp
				tmp=startX
				startX=endX
				endX=tmp
			end
			for i=points[2][2], points[1][2], -1 do
				self:horizLine(startX, i, endX-startX)
				startX=startX+xSlope1
				endX=endX+xSlope2
			end
		else
			local xSlope=(points[3][2]-points[1][2])/(points[3][1]-points[1][1])
			local newX2=points[1][1]+1/xSlope*(points[2][2]-points[1][2])
			self:fillTriangle(points[2][1], points[2][2], newX2, points[2][2], points[3][1], points[3][2])
			self:fillTriangle(points[2][1], points[2][2], newX2, points[2][2], points[1][1], points[1][2])
		end
	end
end