--include "lib\menu.lua"
--include "lib\errorHandler.lua"

local numMineSett=15
local setts={
	["BW"]={ant=9, n="BW", name="Board Width", typ="num", data={["inc"]=1, ["min"]=9, ["max"]=20}},
	["BH"]={ant=9, n="BH", name="Board Height", typ="num", data={["inc"]=1, ["min"]=9, ["max"]=20}},
	["M"]={ant=10, n="M", name="Mines", typ="num", data={["inc"]=function(list, key) --[[local tmp=list["M"].data["max"](list)-list["M"].data["min"] tmp=math.pow(tmp, 1/numMineSett) local tmp2=math.log(list["M"].ant-list["M"].data["min"])/math.log(tmp) if list["M"].ant==list["M"].data["min"] then tmp2=0 end tmp2=tmp2+key print("googe", tmp, tmp2) tmp=math.pow(tmp, tmp2+1)-math.pow(tmp, tmp2) print("googe2", tmp, tmp2, list["M"].data["max"](list), list["M"].data["min"]) ]] local tmp=list["M"].data["max"](list)-list["M"].data["min"] tmp=tmp/numMineSett return tmp end, ["min"]=10, ["max"]=function(list) return (list["BW"].ant-1)*(list["BH"].ant-1) end}}
}


do game=cpyTable(process)
	local gameSettings={}
	local field={}
	local mines={}
	
	local dispData={bounds={(dispX-dispY)/2, 0, dispY, dispY}, sqrSize=20}
	
	local numMines=10
	local brdSize={}
	local check={1, 1, brdSize[1], brdSize[2]}
	
	local savedGames={}
	local numSaves=5
	
	local spaceLeft=60
	local uncover=true
	
	local first=false
	
	local symbols={
		
	}
	
	do game.gameMenu=cpyTable(menu)
		function game.gameMenu:activate()
			PullProcess()
		end
		
		function game.gameMenu:escapeKey()
			PullProcess()
		end
	end
	
	do saveSelect=cpyTable(menu)
		function saveSelect:activate()
			PullProcess()
		end
		
		function saveSelect:escapeKey()
			PullProcess()
		end
	end
	
	do endScreen=cpyTable(menu)
		endScreen.won=false
		
		function endScreen:set(won)
			self.title="You won"
			if not won then
				self.title="You lost"
			end
			self.title=self.title..". Play again?"
		end
		
		function endScreen:enterKey()
			PullProcess()
			PullProcess()
			if self.x==1 then
				game.gameMenu.x=1
				PushProcess(game)
			end
		end
	end
	
	function setDispData()
		local x=dispX-spaceLeft
		local y=dispY
		x=math.floor(x/brdSize[1])
		y=math.floor(y/brdSize[2])
		local unitUsed=x
		if unitUsed>y then
			unitUsed=y
		end
		for i=3, 4 do
			dispData.bounds[i]=unitUsed*brdSize[i-2]
		end
		dispData.bounds[1]=dispX-dispData.bounds[3]
		dispData.bounds[2]=(dispY-dispData.bounds[4])/2
		dispData.sqrSize=unitUsed
	end
	
	function lose()
		endScreen:set(false)
		PushProcess(endScreen)
	end
	
	function win()
		endScreen:set(true)
		PushProcess(endScreen)
	end
	
	function numSurroundMines(xy)
		local tmp=0
		for x=-1, 1 do
			for y=-1, 1 do
				local n=cpyTable(xy)
				n[1]=n[1]+x
				n[2]=n[2]+y
				if checkBounds(n, check) then
					if field[n[1]][n[2]].typ=="mine" then
						tmp=tmp+1
					end
				end
			end
		end
		return tmp
	end
	
	function createField(xy)
		local tmp={}
		field={}
		local f=1
		for i=0, brdSize[1]-1 do
			field[i+1]={}
			for j=1, brdSize[2] do
				if i+1~=xy[1] or j~=xy[2] then
					tmp[f]=i*brdSize[2]+j
					f=f+1
				end
				field[i+1][j]={hidden=true, disp="normal", typ="none"}
			end
		end
		
		for i=1, numMines do
			local n=math.random(1, #tmp)
			mines[i]=tmp[n]
			field[math.ceil(tmp[n]/brdSize[2])][(tmp[n]-1)%brdSize[2]+1].typ="mine"
			table.remove(tmp, n)
		end
		
		for i=1, brdSize[1] do
			for j=1, brdSize[2] do
				if field[i][j].typ~="mine" then
					field[i][j].numMines=numSurroundMines({i, j})
				end
			end
		end
	end
	
	function saveGame()
		savedGames[saveSelect.x]={}
		savedGames[saveSelect.x].field=cpyTable(field)
		savedGames[saveSelect.x].mines=cpyTable(mines)
		savedGames[saveSelect.x].numMines=cpyTable(numMines)
	end
	
	function loadGame()
		first=false
		field=nil
		field=cpyTable(savedGames[saveSelect.x].field)
		mines=cpyTable(savedGames[saveSelect.x].mines)
		numMines=cpyTable(savedGames[saveSelect.x].numMines)
		if field==nil or field=={} then
			first=true
			field=nil
		end
	end
	
	function getXY()
		local xy={mouse:x(), mouse:y()}
		if not checkBounds(xy, dispData.bounds) then
			return nil
		end
		for i=1, #xy do
			xy[i]=xy[i]-dispData.bounds[i]
			xy[i]=math.floor(xy[i]/dispData.bounds[i+#xy]*brdSize[i])+1
			if xy[i]>brdSize[i] then
				xy[i]=brdSize[i]
			end
		end
		return xy
	end
	
	function unHide(xy)
		if checkBounds(xy, check) then
			if field[xy[1]][xy[2]].typ~="mine" and field[xy[1]][xy[2]].hidden then
				field[xy[1]][xy[2]].hidden=false
				if field[xy[1]][xy[2]].numMines==0 then
					unHide({xy[1], xy[2]+1})
					unHide({xy[1], xy[2]-1})
					unHide({xy[1]+1, xy[2]})
					unHide({xy[1]-1, xy[2]})
				end
			end
		end
	end
	
	function game:mouseDown()
		local xy=getXY()
		if not xy then
			return
		end
		if first then
			createField(xy)
			first=false
		end
		if uncover then
			if field[xy[1]][xy[2]].typ=="mine" then
				lose()
			elseif field[xy[1]][xy[2]].typ~="mine" and field[xy[1]][xy[2]].hidden then
				unHide(xy)
			end
		else
			if field[xy[1]][xy[2]].hidden and numMines>0 then
				numMines=numMines-1
				field[xy[1]][xy[2]].hidden=false
				field[xy[1]][xy[2]].disp="flag"
			elseif field[xy[1]][xy[2]].disp=="flag" then
				numMines=numMines+1
				field[xy[1]][xy[2]].hidden=true
				field[xy[1]][xy[2]].disp="normal"
			end
		end
		local won=true
		for i=1, brdSize[1] do
			for j=1, brdSize[2] do
				if field[i][j].hidden then
					won=false
				end
			end
		end
		if won then
			win()
		end
		disp:invalidate()
	end
	
	function game:charIn(c)
		if c=="f" or c=="F" then
			uncover=not uncover
		end
		cursor.show()
		disp:invalidate()
	end
	
	function game:paint(gc)
		gc:setColorRGB(0x00FFFF)
		gc:fillRect(0,0,dispX, dispY)
		gc:setColorRGB(0x000000)
		gc:drawString("Num mines: "..numMines, 0, 0)
		local str="Uncovering..."
		if not uncover then
			str="Placing flags..."
		end
		gc:drawString(str, 0, gc:getStringHeight("H"))
		gc:setFont("serif", "r", dispData.sqrSize-3)
		drawBoard(gc, brdSize[1], brdSize[2], dispData.bounds[1], dispData.bounds[2], dispData.bounds[3], dispData.bounds[4])
		if field~=nil and field~={} then
			for i=1, brdSize[1] do
				for j=1, brdSize[2] do
					local cntr={dispData.bounds[1]+dispData.sqrSize*(i-0.5), dispData.bounds[2]+dispData.sqrSize*(j-0.5)}
					if not field[i][j].hidden then
						local dispLetter=" "
						if field[i][j].disp=="flag" then
							dispLetter="F"
						elseif field[i][j].typ=="mine" then
							dispLetter="M"
						elseif field[i][j].numMines>0 then
							dispLetter=""..field[i][j].numMines
						end
						gc:setColorRGB(0xFFFFFF)
						gc:fillRect(cntr[1]-dispData.sqrSize/2+1, cntr[2]-dispData.sqrSize/2+1, dispData.sqrSize-1, dispData.sqrSize-1)
						gc:setColorRGB(0x000000)
						centerText(gc, dispLetter, cntr[1], cntr[2])
					end
				end
			end
		end
	end
	
	function game:escapeKey()
		PullProcess()
	end
	
	function game:Close()
		saveGame()
	end
	
	function game:setMenus()
		self.gameMenu:reset()
		saveSelect:reset()
		self.gameMenu:add("New Game", saveSelect)
		self.gameMenu:add("Load Game", saveSelect)
		for i=1, numSaves do
			saveSelect:add("Save "..i, game)
		end
		endScreen:add("Yes")
		endScreen:add("No")
	end
	
	function game:Open()
		gameSettings=settings:getSetting("game")
		brdSize={gameSettings["BW"].ant, gameSettings["BH"].ant}
		numMines=gameSettings["M"].ant
		check={1, 1, brdSize[1], brdSize[2]}
		setDispData()
		if game.gameMenu.x==1 then
			field=nil
			first=true
		else
			loadGame()
		end
	end
end

function on.construction()
	lockTopProcess=true
	game:setMenus()
	menu:add("play", game.gameMenu)
	menu:add("settings", settings)
	settings:addSettings(setts, "game")
	PushProcess(menu)
end